<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Box.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_box_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Box.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_box_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_BOX_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_BOX_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vertex_8hpp.html">Vertex.hpp</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_ray_8hpp.html">Ray.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="class_box.html">   12</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_box.html">Box</a>{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="class_box.html#ad1f3063a392fa6d1fc2b5aec6d8f0b3c">   15</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_box.html#ad1f3063a392fa6d1fc2b5aec6d8f0b3c">min</a>, <a class="code" href="class_box.html#ae853f5935d9a8aa3823993d6d80e0300">max</a>, <a class="code" href="class_box.html#ad846af015e917b52877ca9af26e771f8">extent</a>;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="class_box.html#aca78d7db44972bfa78d46b7bbc8796f6">   17</a></span>&#160;    <a class="code" href="class_box.html#aca78d7db44972bfa78d46b7bbc8796f6">Box</a> () {}</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <a class="code" href="class_box.html#aca78d7db44972bfa78d46b7bbc8796f6">Box</a> (<a class="code" href="class_vec.html">Vec</a> p);</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <a class="code" href="class_box.html#aca78d7db44972bfa78d46b7bbc8796f6">Box</a> (<a class="code" href="class_vec.html">Vec</a> min, <a class="code" href="class_vec.html">Vec</a> max);</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        </div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_box.html#a6a5e09398e85d602a046b429062fb9c2">   23</a></span>&#160;    <a class="code" href="class_box.html#a6a5e09398e85d602a046b429062fb9c2">~Box</a>(){}</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_box.html#af8eb0b6a51547413ba7b644c03ba733f">hit</a>(<span class="keyword">const</span> <a class="code" href="class_ray.html">Ray</a>&amp; r, <span class="keywordtype">double</span> *tnear, <span class="keywordtype">double</span> *tfar);</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_box.html#aa440a95b15ae156b61dc6952440ecf4d">expandToInclude</a>(<span class="keyword">const</span> <a class="code" href="class_box.html">Box</a>&amp; b);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;  </div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_box.html#aa440a95b15ae156b61dc6952440ecf4d">expandToInclude</a>(<span class="keyword">const</span> <a class="code" href="class_vec.html">Vec</a>&amp; p);</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    uint32_t <a class="code" href="class_box.html#a09a048ff5995a621847e675e9bf51856">maxDimension</a>();</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    </div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">double</span> <a class="code" href="class_box.html#a3a04958793a3430d2bcab9a819c77d33">surfaceArea</a>();</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;};</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_box_html_af8eb0b6a51547413ba7b644c03ba733f"><div class="ttname"><a href="class_box.html#af8eb0b6a51547413ba7b644c03ba733f">Box::hit</a></div><div class="ttdeci">bool hit(const Ray &amp;r, double *tnear, double *tfar)</div><div class="ttdef"><b>Definition:</b> Box.cpp:14</div></div>
<div class="ttc" id="_ray_8hpp_html"><div class="ttname"><a href="_ray_8hpp.html">Ray.hpp</a></div></div>
<div class="ttc" id="class_box_html_aca78d7db44972bfa78d46b7bbc8796f6"><div class="ttname"><a href="class_box.html#aca78d7db44972bfa78d46b7bbc8796f6">Box::Box</a></div><div class="ttdeci">Box()</div><div class="ttdef"><b>Definition:</b> Box.hpp:17</div></div>
<div class="ttc" id="_vertex_8hpp_html"><div class="ttname"><a href="_vertex_8hpp.html">Vertex.hpp</a></div></div>
<div class="ttc" id="class_box_html_a09a048ff5995a621847e675e9bf51856"><div class="ttname"><a href="class_box.html#a09a048ff5995a621847e675e9bf51856">Box::maxDimension</a></div><div class="ttdeci">uint32_t maxDimension()</div><div class="ttdef"><b>Definition:</b> Box.cpp:77</div></div>
<div class="ttc" id="class_box_html_ad846af015e917b52877ca9af26e771f8"><div class="ttname"><a href="class_box.html#ad846af015e917b52877ca9af26e771f8">Box::extent</a></div><div class="ttdeci">Vec extent</div><div class="ttdef"><b>Definition:</b> Box.hpp:15</div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_box_html_a6a5e09398e85d602a046b429062fb9c2"><div class="ttname"><a href="class_box.html#a6a5e09398e85d602a046b429062fb9c2">Box::~Box</a></div><div class="ttdeci">~Box()</div><div class="ttdef"><b>Definition:</b> Box.hpp:23</div></div>
<div class="ttc" id="class_box_html_a3a04958793a3430d2bcab9a819c77d33"><div class="ttname"><a href="class_box.html#a3a04958793a3430d2bcab9a819c77d33">Box::surfaceArea</a></div><div class="ttdeci">double surfaceArea()</div><div class="ttdef"><b>Definition:</b> Box.cpp:84</div></div>
<div class="ttc" id="class_box_html_aa440a95b15ae156b61dc6952440ecf4d"><div class="ttname"><a href="class_box.html#aa440a95b15ae156b61dc6952440ecf4d">Box::expandToInclude</a></div><div class="ttdeci">void expandToInclude(const Box &amp;b)</div><div class="ttdef"><b>Definition:</b> Box.cpp:65</div></div>
<div class="ttc" id="class_box_html"><div class="ttname"><a href="class_box.html">Box</a></div><div class="ttdef"><b>Definition:</b> Box.hpp:12</div></div>
<div class="ttc" id="class_box_html_ae853f5935d9a8aa3823993d6d80e0300"><div class="ttname"><a href="class_box.html#ae853f5935d9a8aa3823993d6d80e0300">Box::max</a></div><div class="ttdeci">Vec max</div><div class="ttdef"><b>Definition:</b> Box.hpp:15</div></div>
<div class="ttc" id="class_box_html_ad1f3063a392fa6d1fc2b5aec6d8f0b3c"><div class="ttname"><a href="class_box.html#ad1f3063a392fa6d1fc2b5aec6d8f0b3c">Box::min</a></div><div class="ttdeci">Vec min</div><div class="ttdef"><b>Definition:</b> Box.hpp:15</div></div>
<div class="ttc" id="class_ray_html"><div class="ttname"><a href="class_ray.html">Ray</a></div><div class="ttdoc">A class to create and manipulate 3D rays. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:12</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_box_8hpp.html">Box.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
